#!/usr/bin/perl
#
# CSVデータからRDFデータ(turtle形式)に変換する
#
#

use strict;
use warnings;
use Switch;
use File::Basename;

# require設定
require "diam_microbe_ident2.pl";
require "diam_microbe_ident4.pl";
require "diam_microbe_ident8.pl";
require "diam_microbe_util5.pl";

# 引数の処理
my $file = shift;
unless ($file) {
	# 引数がないときは、使用方法を示して終了。
	die "Usage: csv2rdf.pl [ nies.csv | diam_microbe_ident2.csv | diam_microbe_ident4.csv | \n diam_microbe_ident8.csv | diam_microbe_util5.csv ]\n"; 
}

# ファイルを解析してcsv形式のデータを配列の配列に変換。
create_turtle($file);
#parse_file($file);



# create turtle string
sub create_turtle{
	my $csvfile = $_[0];

        # ファイルOPEN
        open(my $fh, "<", $csvfile)
                or die "Cannot open $csvfile for read: $!";


	# fileによって処理を分岐
	my $file = basename($csvfile);
	switch($file) {
		case "nies.csv" {
			`php ./nies.php $csvfile`;
			`mv ./out.ttl ../nies/rdf/nies.ttl`;
		}
		case "diam_microbe_ident2.csv"  {
			csv2rdf::make_rdf_ident2_main($fh, $csvfile);
		}
		case "diam_microbe_ident4.csv" {
			csv2rdf::make_rdf_ident4_main($fh, $csvfile);
		}
		case "diam_microbe_ident8.csv" {
			csv2rdf::make_rdf_ident8_main($fh, $csvfile);
		}
		case "diam_microbe_util5.csv" {
			csv2rdf::make_rdf_util5_main($fh, $csvfile);
		}
		else {
			die "Cannot find the csvfile( $csvfile ) to create the rdffile. ";
		}
	}

	close $fh;
}
