#!/usr/bin/perl
#
# diam_microbe_xxxx(テンプレート)
#
#

package csv2rdf;

use Text::CSV_XS;
use Text::CSV;
use IO::File;
use utf8;

binmode STDOUT, ':utf8';

# TaxsonomyId
$taxurl ="http://identifiers.org/taxonomy/";

#--------------------------------------------------------------------------------
# diam_microbe_ident4.csvのTurtle処理
# 基準株 (Bacteriaの化学成分情報）
#--------------------------------------------------------------------------------
sub make_rdf_ident4_main {

        my $fh = $_[0];
	my $filename = $_[1];

        # RDF Header
        my $header = '@prefix xml: <http://www.w3.org/XML/1998/namespace>'.".\n".'@prefix rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>'.".\n".'@prefix mccv: <http://purl.jp/bio/01/mccv#>'.".\n".'@prefix prism: <http://prismstandard.org/namespaces/basic/2.0/>'.".\n";

        # header出力
        printf $header."\n";

        # ファイル読み込み
	my $csv = Text::CSV->new ({ binary => 1, eol => $/ });
	open my $io, "<", $filename or die "$filename: $!";
	#my $file = IO::File->new($filename, "r");

	$line_cnt = 0;
        #while (not $file->eof and my $items = $csv->getline($file)) {	
	while (my $items = $csv->getline ($io)) {
		if($line_cnt == 0) {
			$line_cnt++;
			next;
		}

                # カラム単位で処理
                make_rdf_ident4_str($items);

		$line_cnt++;
        }
}


#--------------------------------------------------------------------------------
# diam_microbe_ident4.csvのカラムごとの出力処理
#--------------------------------------------------------------------------------
sub make_rdf_ident4_str {

	# ブランクノード
	printf "[]\n";

        my $items = $_[0];

	# カラム取得
	$species = $items->[0];
	$taxid = $items->[1];
	$strains = $items->[2];

        # 生物種
        printf("mccv:MCCV_000011 \"%s\";\n", $species);

	# OtherStrainNumber
	# 「=」で分割
	@strain = split(/=/, $strains);
	for($i = 0;$i < @strain;$i++ ){
		print_osn(@strain[$i]);
	}

        # TaxonomyId
        printf("mccv:MCCV_000065 <%s%s>;\n", $taxurl, $taxid);


	printf("a mccv:MCCV_000002\n");

	printf ".\n\n";

}

# OtherStrainNumber出力
sub print_osn {
	$osn = $_[0];

	# 前後の半角ブランクを削除
	$osn =~ s/^ //;
	$osn =~ s/ $//;
	# 半角ブランクで分割
	@param = split(/ /, $osn);
	$prefix = @param[0];
	$number = @param[1];
	$number =~ s/ $//;

	# prefixが指定された値の場合
	$uri ="";
	if($prefix eq "ATCC") {
		# ATTC
		$uri ="http://www.atcc.org/Products/All/$number";
		printf("mccv:MCCV_000026 <%s>;\n", $uri);
	} elsif($prefix eq "LMG") {
		# LMG
		$uri ="http://bccm.belspo.be/db/lmg_strain_details.php?NUM=$number";
		printf("mccv:MCCV_000026 <%s>;\n", $uri);
 	} else {
		# others
		if($osn ne "" ) {
			printf("mccv:MCCV_000026 \"%s\";\n", $osn);
		}
	}
}


1;
