<?php
function getOrganismType($name){
$SPARQL = <<<EOT
select distinct ?mccv
from <http://togogenome.org/graph/taxonomy>
from <http://togogenome.org/graph/brc>
from <http://togogenome.org/graph/mccv>
where {
 ?s rdfs:label "%s" .
 ?l rdfs:subClassOf* ?s .
 ?brc <http://purl.jp/bio/01/mccv#MCCV_000023> ?l .
 ?brc <http://purl.jp/bio/01/mccv#MCCV_000038> ?mccv .
 ?mccv rdfs:label ?label .
}
EOT;
	
	$SPARQL = sprintf($SPARQL, $name);
	
	$result = execSPARQL($SPARQL);
	
	return count($result) ? $result[0] : null;
	
}

function getHabitat($name){
$SPARQL = <<<EOT
select distinct ?s
from <http://togogenome.org/graph/meo>
where {
?s rdfs:label ?label .
filter( str(?label) in ("%s") )
}
EOT;
	
	$synonymList = array(
		"Freshwater"  => array("freshwater habitat"),
		"Salt water"  => array("saline water habitat"),
		"Marine"      => array("marine habitat"),
		"Terrestrial" => array("terrestrial habitat"),
		"Freshwater marsh"  => array("freshwater habitat"),
	);
	
	$nameList = array(strtolower(trim($name)));
	if(empty($nameList[0])){
		return null;
	}
	if(!empty($synonymList[trim($name)])){
		$nameList = array_merge($nameList, $synonymList[trim($name)]);
	}
	
	$SPARQL = sprintf($SPARQL, implode('","', $nameList));
	
	$result = execSPARQL($SPARQL);
	
	return count($result) ? $result[0] : null;
	
}

function getGazzetter($nameList){
	
	if(empty($nameList)){
		return array();
	}
	
	$name = implode('"^^xsd:string, "', $nameList);
	
	$SPARQL = sprintf('select ?s { ?s rdfs:label ?o . filter( ?o in ("%s"^^xsd:string) )}', $name);
	return execSPARQL($SPARQL);
}

function execSPARQL($sparql){
	$URL = sprintf("http://ep.dbcls.jp/sparql71dev?default-graph-uri=&timeout=0&debug=on&format=text%%2Fcsv&query=%s", urlencode($sparql));
	$fp = fopen($URL, 'r');
	$i = 0;
	while($row = fgetcsv($fp)){
		// ͒`sȂ̂łʂ
		if($i++ == 0){
			continue;
		}
		
		return $row;
	}
	
	return array();
}
?>