<?php
require_once('lib/NIES.class.php');
require_once('lib/smarty/Smarty.class.php');

// ファイル名取得
if(empty($argv[1])){
	echo "Input File Error.";
	exit();
}

stream_context_set_default(array( 'http'=> array('request_fulluri' => true, 'proxy'=> empty($_SERVER["http_proxy"]) ? null : str_replace('http://','tcp://',$_SERVER["http_proxy"]))));

// ファイルの中身を読む
$fp = fopen($argv[1], 'r');
$i = 0;
$niesList = array();
while($row = fgetcsv($fp)){
	// 初回は定義行なのでぬかす
	if($i++ == 0){
		continue;
	}
	
	$nies = new NIES();
	$nies->setFromCSVArray($row);
	$niesList[] = $nies;
	
	echo ($i -1) ." : $nies->subject\n";
}

$smarty = new Smarty();
$smarty->template_dir = dirname( __FILE__ ).'/tpl/';
$smarty->compile_dir = dirname( __FILE__ ).'/templates_c/';
$smarty->assign('prefix', NIES::$PREFIX);
$smarty->assign('list', $niesList);

$data = $smarty->fetch('strain.tpl');
$data = file_put_contents('out.ttl',$data);

// Turtleで使用する文字列に変換
function getTurtleValue($val,$prefix){
	if(!is_array($val)){
		$val = array($val);
	}
	
	foreach($val as $v){
		if(preg_match("#https?://#",$v)){
			foreach($prefix as $pre => $url){
				$v = str_replace($url, $pre, $v);
			}
			if(preg_match("#https?://#",$v)){
				return sprintf("<%s>",$v);
			}
			else{
				return $v;
			}
		}
		else {
			$str = sprintf('"%s"', addslashes($v));
			return $str;
		}
	}
}
